/**
 * ExtUtil: ExtensionŖ𗧂Ȓ^܂Ƃ߂[eBeBNX
 * 
 * ̃t@C𑼂ExtensionɓĂ\܂񂪁Aς͂ȂłB
 */
package extensions;

import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.nio.charset.Charset;
import java.util.Calendar;
import java.util.Collections;
import java.util.Map;
import java.util.Set;
import java.util.Vector;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

import dareka.common.CloseUtil;
import dareka.common.Logger;
import dareka.common.Pair;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.StringResource;
import dareka.processor.URLResource;

// XV:
//
// 100905 (eXgłƂ̌݊͂܂)
// 100909 getInteger()ǉ
//
public class ExtUtil extends Thread implements Extension2, Runnable {
	
	/** ExtUtil̃rW𔻒肷ꍇ͂̒lQƂ */
	public static final int REVISION = 100909;
	public static final String VER_STRING = "ExtUtil_" + REVISION;
	
	private static final Pattern URL_HOST_PATTERN = Pattern.compile("https?://([^/]+)");
	private static final Pattern MIME_CHARSET_PATTERN = Pattern.compile("charset=([^;]+)");
	private static final Pattern LINE_DIGIT_PATTERN = Pattern.compile("^(\\d+)\\s*$");
	private static final Charset FILE_CHARSET = Charset.forName("UTF-8");
	
	private static final Class<?>[] loadMethodTypes = new Class[]{ BufferedReader.class };
	private static final Class<?>[] saveMethodTypes = new Class[]{ BufferedWriter.class };
	private static Set<Pattern> NGtitle;
	private static final Pair<File, Long> NGtitleFileInfo =
			new Pair<File, Long>(new File("list/NGtitle.txt"), 0L);
	private static Set<Integer> NGuserId;
	private static final Pair<File, Long> NGuserIdFileInfo =
			new Pair<File, Long>(new File("list/NGuserId.txt"), 0L);
	
	private static final Vector<ExtUtil> extensions = new Vector<ExtUtil>();
	private static ScheduledExecutorService sched;
	private static ExtUtil self, onMinutesInstance, onShutdownInstance;
	
	private Extension2 caller;
	private String prefix, prefixDebug, propDebug;
	private String methodName;
	private Object[] params;
	
	public ExtUtil() {
		if (sched == null) {
			sched = Executors.newSingleThreadScheduledExecutor();
			sched.scheduleAtFixedRate(
					onMinutesInstance  = new ExtUtil(), 60, 60, TimeUnit.SECONDS);
			Runtime.getRuntime().addShutdownHook(
					onShutdownInstance = new ExtUtil());
			register(self = this, null, null);
			self.debug("setting up now.");
		}
	}
	
	// pɌX̏ԂێCX^X𐶐
	private ExtUtil(Extension2 caller, String methodName, Object param) {
		this.caller = caller;
		this.methodName = methodName;
		if (param != null) {
			this.params = new Object[]{ param };
		}
	}
	
	// Extension2 interface
	public void registerExtensions(ExtensionManager mgr) {
		// ExtensionƂĂ͉Ȃ
	}
	
	public String getVersionString() {
		return VER_STRING;
	}
	
	// Runnable interface
	public void run() {
		if (caller != null) {
			Class<?>[] types = null;
			if (params != null) {
				types = new Class[]{ params[0].getClass() };
			}
			callMethod(null, caller, methodName, types, params);
		} else if (this == onMinutesInstance) {
			for (ExtUtil util : extensions) {
				callMethod(null, util.caller, "onMinutes", null);
			}
		} else if (this == onShutdownInstance) {
			for (ExtUtil util : extensions) {
				callMethod(null, util.caller, "onShutdown", null);
			}
		}
	}
	
	/**
	 * ExtUtil̃CX^X𐶐
	 * <p>
	 * ĂяȍKvƂAPI̓CX^X\bhƂĎĂB
	 * ̂߁AAPI𗘗pɂ́ACX^X𐶐ČĂяo
	 * ExtensionExtUtilɓo^KvB
	 * ܂AĂяoExtensionňȉ̃\bh`邱ƂŁACxg
	 * ExtUtilR[obN󂯎邱ƂłB
	 * <pre>
	 * public void onMinutes():
	 *   1ԊuŌĂяoBVOXbhœo^ꂽExtension
	 *   ԂɌĂяôŁAKԊuŌĂяo킯ł͂ȂB
	 * public void onShutdown():
	 *   shutdownɌĂяoBۑ̏IsłB
	 *   
	 * reflact APIgēIɃ\bĥŁAinterfacê悤
	 * K\bh`Kv͖(gȂ̂͒`Ȃėǂ)B</pre>
	 * 
	 * @param extension o^ExtensioñCX^X
	 * @param prefix    O\鎞̃vtBbNX(nullȂĂяoNX)
	 * @param propDebug fobO[hԂ擾vpeB(nullȂ<b>prefix</b>+"Debug")
	 * @throws IllegalArgumentException extensionnull̏ꍇ
	 */
	public ExtUtil(Extension2 extension, String prefix, String propDebug) {
		if (extension == null) {
			throw new IllegalArgumentException("extension must not be null.");
		}
		register(extension, prefix, propDebug);
	}
	
	private void register(Extension2 caller, String prefix, String propDebug) {
		if (prefix == null) {
			prefix = caller.getClass().getName().substring("extensions.".length());
		}
		if (propDebug == null) {
			propDebug = prefix.concat("Debug");
		}
		this.caller = caller;
		this.prefix      = prefix.concat(": ");
		this.prefixDebug = prefix.concat(":[DEBUG] ");
		this.propDebug = propDebug;
		extensions.add(this);
	}
	
	/**
	 * 񃍃Oo͂
	 * 
	 * @param message O
	 */
	public void info(String message) {
		Logger.info(prefix.concat(message));
	}
	
	/**
	 * 񃍃OtH[}bgďo͂
	 * 
	 * @param format tH[}bg
	 * @param args tH[}bgp[^
	 */
	public void info(String format, Object...args) {
		Logger.info(prefix.concat(format), args);
	}
	
	
	/**
	 * xOo͂
	 * 
	 * @param message O
	 */
	public void warn(String message) {
		Logger.warning(prefix.concat(message));
	}
	
	/**
	 * xOtH[}bgďo͂
	 * 
	 * @param format tH[}bg
	 * @param args tH[}bgp[^
	 */
	public void warn(String format, Object...args) {
		Logger.warning(String.format(prefix.concat(format), args));
	}
	
	/**
	 * fobO[hH
	 * 
	 * @return fobO[hȂtrue
	 */
	public boolean isDebug() {
		return Boolean.getBoolean(propDebug);
	}
	
	/**
	 * fobOOo͂
	 * 
	 * @param message O
	 */
	public void _DBG(String message) {
		Logger.info(prefixDebug.concat(message));
	}
	
	/**
	 * fobO[hȂfobOOtH[}bgďo͂
	 * 
	 * @param format tH[}bg
	 * @param args tH[}bgp[^
	 */
	public void debug(String format, Object...args) {
		if(isDebug())_DBG(String.format(format, args));
	}
	
	/**
	 * Xbh𐶐Ďw胁\bhĂяo
	 * 
	 * @param methodName Ăяo\bh()
	 */
	public void execute(String methodName) {
		execute(methodName, null);
	}
	
	/**
	 * Xbh𐶐Ďw胁\bhtŌĂяo
	 * 
	 * @param methodName Ăяo\bh(T)
	 * @param param w胁\bhɓn
	 */
	public <T> void execute(String methodName, T param) {
		(new ExtUtil(caller, methodName, param)).start();
	}
	
	/**
	 * xԌɎw胁\bhĂяo
	 * 
	 * @param methodName Ăяo\bh()
	 * @param delay x(~b)
	 */
	public void setSchedule(String methodName, long delay) {
		sched.schedule(new ExtUtil(caller, methodName, null), delay, TimeUnit.MILLISECONDS);
	}
	
	/**
	 * xԌɎw胁\bhtŌĂяo
	 * 
	 * @param methodName Ăяo\bh(T)
	 * @param param w胁\bhɓn
	 * @param delay x(~b)
	 */
	public <T> void setSchedule(String methodName, T param, long delay) {
		sched.schedule(new ExtUtil(caller, methodName, param), delay, TimeUnit.MILLISECONDS);
	}
	
	/**
	 * X|XpɃLbVȂ񃊃\[XԂ
	 * 
	 * @param text X|X
	 * @param contentType Reg^Cv(ȗ"text/plain")
	 * @return 񃊃\[X
	 */
	public static StringResource responseText(String text, String contentType) {
		StringResource r = new StringResource(text);
		if (contentType != null) {
			r.setResponseHeader(HttpHeader.CONTENT_TYPE, contentType);
		}
		r.addNoCacheResponseHeaders();
		return r;
	}
	
	/** @see {@link #responseText(String, String)} */
	public static StringResource responseText(String text) {
		return responseText(text, "text/plain");
	}
	
	/**
	 * LbVtH_ȉɂt@CIuWFNgԂ
	 * 
	 * @param path LbVtH_ȉ̑΃pX
	 * @return t@CIuWFNg
	 */
	public static File cacheFolderFile(String path) {
		String cacheFolder = System.getProperty("cacheFolder", "");
		if (cacheFolder.length() > 0) {
			cacheFolder = cacheFolder.replace(
					File.separatorChar, '/').replaceFirst("/$", "");
		} else {
			cacheFolder = "cache";
		}
		return new File(cacheFolder + "/" + path);
	}
	
	/**
	 * VXevpeB̐lŏlEől̐tŎ擾
	 * 
	 * @param name 擾vpeB
	 * @param def ftHgl(ŏlEől͈͓̔ł邱)
	 * @param min ŏl
	 * @param max ől
	 * @return
	 */
	public static int getInteger(String name, int def, int min, int max) {
		int value = def;
		String property = System.getProperty(name);
		try {
			if(property != null) value = Integer.parseInt(property);
		} catch (NumberFormatException e) {
			self.debug("property '%s' is not a integer.", property);
		}
		return (value < min) ? min : (value > max) ? max : value;
	}
	
	/** @see {@link #getInteger(String, int, int, int)} */
	public static int getInteger(String name, int def, int min) {
		return getInteger(name, def, min, Integer.MAX_VALUE);
	}
	
	/**
	 * NGXgwb_URLݒ肷BHostwb_ݒ肷B
	 * ܂A\bhGETɐݒAContent-Typewb_͍폜B
	 * 
	 * @param requestHeader ݒΏۂ̃NGXgwb_
	 * @param url ݒ肷URL
	 * @param setReferer trueȂrequestHeader.getURI()̓eRefererɐݒ肷B
	 *                   falseȂRefererNA
	 * @return URLݒ肵NGXgwb_
	 */
	public static HttpRequestHeader setURL(
			HttpRequestHeader requestHeader, String url, boolean setReferer) {
		if (requestHeader != null) {
			if (setReferer) {
				requestHeader.setMessageHeader("Referer", requestHeader.getURI());
			} else {
				requestHeader.removeMessageHeader("Referer");
			}
			requestHeader.setMethod("GET");
			requestHeader.setURI(url);
			Matcher m = URL_HOST_PATTERN.matcher(url);
			if (m.find()) {
				requestHeader.setMessageHeader("Host", m.group(1));
			}
			requestHeader.removeMessageHeader(HttpHeader.CONTENT_TYPE);
		}
		return requestHeader;
	}
	
	/**
	 * X|Xwb_Content-Type當Zbg擾
	 * 
	 * @param responseHeader 擾Ώۂ̃X|Xwb_
	 * @return 擾ZbgA擾łȂꍇUTF-8Ԃ
	 */
	public static String getCharset(HttpResponseHeader responseHeader) {
		String charset = "UTF-8";
		String contentType = responseHeader.getMessageHeader(HttpHeader.CONTENT_TYPE);
		if (contentType != null) {
			Matcher m = MIME_CHARSET_PATTERN.matcher(contentType);
			if(m.matches()) charset = m.group(1).trim();
		}
		return charset;
	}
	
	/**
	 * NGXgwb_HTTPANZXČʂ𕶎ɂĕԂȈՃ\bh
	 * <p>
	 * ̃\bhgɂ́AŒNGXgwb_ɃANZXURLݒ肷B
	 * Kvɉ"Host","Accept-Ancoding","Content-Type"Ƃwb_ݒ肳B
	 * POST̏ꍇContent-Type"application/x-www-form-urlencoded"ݒ肷B
	 * 
	 * @param requestHeader NGXgwb_
	 * @param postString GET̏ꍇnullAPOST̏ꍇPOST镶w肷
	 * @return X|X{fBAXe[^X200ȊȌꍇnull
	 */
	public static String http_get(HttpRequestHeader requestHeader, String postString) {
		String url = requestHeader.getURI();
		Matcher m = URL_HOST_PATTERN.matcher(url);
		if (m.matches()) {
			requestHeader.setMessageHeader("Host", m.group(1));
		}
		InputStream bin = null;
		if (postString == null) {
			requestHeader.setMethod("GET");
			requestHeader.removeMessageHeader(HttpHeader.CONTENT_TYPE);
		} else {
			bin = new ByteArrayInputStream(postString.getBytes());
			requestHeader.setMethod("POST");
			requestHeader.setMessageHeader(
					HttpHeader.CONTENT_TYPE, "application/x-www-form-urlencoded");
		}
		HttpResponseHeader responseHeader = null;
		try {
			URLResource r = new URLResource(requestHeader.getURI());
			r.setFollowRedirects(true);
			// NicoCacheT|[gĂGR[fBÔݐݒ
			requestHeader.setMessageHeader("Accept-Encoding", "gzip, deflate");
			responseHeader = r.getResponseHeader(bin, requestHeader);
			if (responseHeader != null && responseHeader.getStatusCode() == 200) {
				byte[] body = r.getResponseBody();
				if(body != null) return new String(body, getCharset(responseHeader));
			}
		} catch (IOException e) {
			if (self.isDebug()) {
				Logger.error(e);
				self._DBG("requestHeader:\n" + requestHeader);
				if (responseHeader != null) {
					self._DBG("responseHeader:\n" + responseHeader);
				}
			}
			self.warn(requestHeader.getMethod()+" "+url+" failed.");
		}
		return null; // FAILURE
	}
	
	/** @see {@link #http_get(HttpRequestHeader, String)} */
	public static String http_get(HttpRequestHeader requestHeader) {
		return http_get(requestHeader, null);
	}
	
	/**
	 * NẌstatic\bh𓮓IɌĂяoČʂԂ
	 * 
	 * @param className ĂяoNXBExtension̏ꍇ"extensions.`"
	 * @param methodName Ăяo\bh
	 * @return Ăяoʂi[IuWFNgAsꍇnull
	 */
	public static Object callMethod(String className, String methodName) {
		try {
			Class<?> k = Class.forName(className);
			return callMethod(k, null, methodName, null);
		} catch (ClassNotFoundException e) {
			self.debug("class '%s' not found.", className);
		}
		return null; // FAILURE
	}
	
	/**
	 * NX̃\bh𓮓IɌĂяoČʂԂ
	 * 
	 * @param k ĂяoNXClassIuWFNgAnullw肵ꍇinstance擾
	 * @param instance ĂяoIuWFNg̃CX^XAstatic\bh̏ꍇnull
	 * @param methodName Ăяo\bh
	 * @param parameterTypes Ăяo\bḧ^̔zȀꍇnull
	 * @param parameters Ăяo\bḧ̔zȀꍇnull
	 * @return Ăяoʂi[IuWFNgAsꍇnull
	 */
	public static Object callMethod(Class<?> k, Object instance,
			String methodName, Class<?>[] parameterTypes, Object...parameters) {
		assert k != null || instance != null;
		try {
			if (k == null && instance != null)
				k = instance.getClass();
			Method m = k.getMethod(methodName, parameterTypes);
			Object result = m.invoke(instance, parameters);
			self.debug("%s%c%s() called, instance=%s, result=%s.", k.getName(),
					instance != null ? '#' : '.', methodName, instance, result);
			return result;
		} catch (NoSuchMethodException e) {
			self.debug("%s#%s() not found.", k.getName(), methodName);
		} catch (IllegalAccessException e) {
			if(self.isDebug()) Logger.error(e);
		} catch (SecurityException e) {
			if(self.isDebug()) Logger.error(e);
		} catch (InvocationTargetException e) {
			if(self.isDebug()) Logger.error(e);
		}
		return null; // FAILURE
	}
	
	/**
	 * t@CXVĂΓǂݍ݃\bhĂяo
	 * <p>
	 * fileInfoɓǂݍ݂t@C̏Pair<File, Long>ŗ^B
	 * Filel͓ǂݍ݂t@CFileIuWFNgALongl̓t@C
	 * ŏIXVݒ肷(ŏɕKǂݍ݂Ȃ0Lݒ)B
	 * t@C݂ꍇALongl̓t@C̍ŏIXVŏ㏑B
	 * t@C݂ȂꍇALongl1Lŏ㏑B
	 * ܂AfileInfo͔r̂߂̃bNIuWFNgƂĂp̂ŁA
	 * \Ȍstatic finalIuWFNgƂĒ`̂]܂B
	 * <p>
	 * loadMethod͈ȉ̌`ŌĂяo\bh`B
	 * <pre>
	 * public void loadMethod(BufferedReader br) throws IOException</pre>
	 * <p>
	 * brɂ́At@C݂ꍇBufferedReader̃CX^X^邪A
	 * t@C݂Ȃꍇnull^BāAbrnullȊȌꍇ
	 * t@CRNVɒlǂݍ݁Abrnull̏ꍇ̓RNV
	 * NAAƂgłB
	 * <p>
	 * {\bh̎gp{@link #matchNGtitle(String)}QƂ̂ƁB
	 * 
	 * @param fileInfo t@CPair<File, Long>ŗ^
	 * @param loadMethod ۂɃt@Cǂݍރ\bh
	 * @param charset t@Cǂݍލۂ̕Zbg(ȗ"UTF-8")
	 * @return loadMethodĂяoȂtrue
	 */
	public boolean loadFile(Pair<File, Long> fileInfo, String loadMethod, Charset charset) {
		BufferedReader br = null;
		long lastmod = fileInfo.first.lastModified();
		if (fileInfo.second < lastmod) {
			fileInfo.second = lastmod;
			synchronized (fileInfo) {
				debug("loading '%s'...", fileInfo.first);
				try {
					br = new BufferedReader(new InputStreamReader(
							new FileInputStream(fileInfo.first), charset));
					callMethod(null, caller, loadMethod, loadMethodTypes, br);
					return true;
				} catch (IOException e) {
					Logger.error(e);
					warn("loading '%s' failed.", fileInfo.first);
				} finally {
					CloseUtil.close(br);
				}
			}
		} else if (lastmod == 0L && !fileInfo.first.exists()) {
			if (fileInfo.second != 1L) {
				fileInfo.second  = 1L;
				synchronized (fileInfo) {
					debug("loading '%s' is none.", fileInfo.first);
					callMethod(null, caller, loadMethod, loadMethodTypes, br);
					return true;
				}
			}
		}
		return false;
	}
	
	/** @see {@link #loadFile(Pair, String, Charset)} */
	public boolean loadFile(Pair<File, Long> fileInfo, String loadMethod) {
		return loadFile(fileInfo, loadMethod, FILE_CHARSET);
	}
	
	/**
	 * o\bhĂяoăt@CXV
	 * <p>
	 * fileInfoŗ^t@C̓eXVāAXV㏑B
	 * ot@C̓fC[ŃobNAbv쐬B
	 * <p>
	 * saveMethod͈ȉ̌`ŌĂяo\bh`B
	 * <pre>
	 * public void saveMethod(BufferedWriter bw) throws IOException</pre>
	 * <p>
	 * bwɂ́AKBufferedWriter̃CX^X^B
	 * loadMethodƈقȂAbwnull^邱Ƃ͖B
	 * 
	 * @see {@link #loadFile(Pair, String, Charset)}
	 * @param fileInfo t@CPair<File, Long>ŗ^
	 * @param saveMethod ۂɃt@Cɏo\bh
	 * @param direct ̒ltrueȂAsaveMethod̕𒼐ڏo
	 * @param charset t@Cɏoۂ̕Zbg(ȗ"UTF-8")
	 * @return t@C̏oɐȂtrue
	 * 
	 */
	public boolean saveFile(Pair<File, Long> fileInfo,
			String saveMethod, boolean direct, Charset charset) {
		boolean saved = false;
		synchronized (fileInfo) {
			renameToBak(fileInfo.first, true);
			debug("saving '%s'...", fileInfo.first);
			BufferedWriter bw = null;
			try {
				bw = new BufferedWriter(new OutputStreamWriter(
						new FileOutputStream(fileInfo.first), charset));
				if (direct) {
					bw.write(saveMethod);
				} else {
					callMethod(null, caller, saveMethod, saveMethodTypes, bw);
				}
				saved = true;
			} catch (IOException e) {
				Logger.error(e);
				warn("saving '%s' failed.", fileInfo.first);
			} finally {
				CloseUtil.close(bw);
				if(saved) fileInfo.second = fileInfo.first.lastModified();
			}
		}
		return saved;
	}
	
	/** @see {@link #saveFile(Pair, String, boolean, Charset)} */
	public boolean saveFile(Pair<File, Long> fileInfo, String saveMethod, boolean direct) {
		return saveFile(fileInfo, saveMethod, direct, FILE_CHARSET);
	}
	
	/** @see {@link #saveFile(Pair, String, boolean, Charset)} */
	public boolean saveFile(Pair<File, Long> fileInfo, String saveMethod) {
		return saveFile(fileInfo, saveMethod, false, FILE_CHARSET);
	}
	
	/**
	 * 悪ߋɍ폜ꂽƂ邩H
	 * <ul>
	 * <li>totalRename̍폜Ɋ܂܂Ă邩H
	 * </ul>
	 * @param smid ID
	 * @return ߋɍ폜ꂽƂtrue
	 */
	@SuppressWarnings("unchecked")
	public static boolean hasRemoved(String smid) {
		Map<String, String> info = (Map<String, String>)callMethod(
				"extensions.totalRenameHelper", "getRemoveInfo");
		return info != null ? info.containsKey(smid) : false;
	}
	
	/**
	 * NG^CgɃ}b`邩H
	 * <ul>
	 * <li>list/NGtitle.txtɊ܂܂Ă邩H
	 * </ul>
	 * @param title ^Cg
	 * @return NG^CgɃ}b`MatcherA}b`ȂnullԂ
	 */
	public static Matcher matchNGtitle(String title) {
		self.loadFile(NGtitleFileInfo, "loadNGtitle");
		if (NGtitle != null) {
			for (Pattern pat : NGtitle) {
				Matcher m = pat.matcher(title);
				if(m.lookingAt()) return m;
			}
		}
		return null;
	}
	
	/** NGtitle[hpR[obN(OĂяoȂ) */
	public void loadNGtitle(BufferedReader br) throws IOException {
		if (br != null) {
			Set<Pattern> s = new java.util.HashSet<Pattern>();
			String line;
			for (int num = 1; (line = br.readLine()) != null; num++) {
				if (line.isEmpty() || line.startsWith("#")) {
					continue;
				} else {
					try {
						s.add(Pattern.compile(line));
					} catch (PatternSyntaxException e) {
						warn("regex error in %s, line %d.",
								NGtitleFileInfo.first, num);
					}
				}
			}
			NGtitle = Collections.synchronizedSet(s);
		} else {
			NGtitle = null;
		}
	}
	
	/**
	 * NG[U[H
	 * <ul>
	 * <li>list/NGuserId.txtɊ܂܂Ă邩H
	 * </ul>
	 * @param userId [U[ID
	 * @return NG[U[Ȃtrue
	 */
	public static boolean isNGuserId(String userId) {
		if (userId.matches("\\d+")) {
			return isNGuserId(new Integer(userId));
		} else {
			self.warn("not a number: ", userId);
		}
		return false;
	}
	
	/** @see {@link #isNGuserId(String)} */
	public static boolean isNGuserId(Integer userId) {
		self.loadFile(NGuserIdFileInfo, "loadNGuserId");
		return NGuserId != null ? NGuserId.contains(userId) : null;
	}
	
	/** NGuserId[hpR[obN(OĂяoȂ) */
	public void loadNGuserId(BufferedReader br) throws IOException {
		if (br != null) {
			Set<Integer> s = new java.util.HashSet<Integer>();
			String line;
			while ((line = br.readLine()) != null) {
				if (line.isEmpty() || line.startsWith("#")) {
					continue;
				} else {
					Matcher m = LINE_DIGIT_PATTERN.matcher(line);
					if(m.matches()) s.add(new Integer(m.group(1)));
				}
			}
			NGuserId = Collections.synchronizedSet(s);
		} else {
			NGuserId = null;
		}
	}
	
	/**
	 * wt@CobNAbvt@CɃl[
	 * 
	 * @param file l[Ώۂ̃t@C(t@C+".bak"ɂȂ)
	 * @param daily trueȂtς閈ɁAfalse(ȗ)ȂɃobNAbv쐬
	 * @return l[true
	 */
	public static boolean renameToBak(File file, boolean daily) {
		if (file.exists()) {
			File file_bak = new File(file.getPath().concat(".bak"));
			if (file_bak.exists()) {
				if (daily) {
					int y1, d1, y2, d2;
					Calendar c = Calendar.getInstance();
					y1 = c.get(Calendar.YEAR);
					d1 = c.get(Calendar.DAY_OF_YEAR);
					c.setTimeInMillis(file_bak.lastModified());
					y2 = c.get(Calendar.YEAR);
					d2 = c.get(Calendar.DAY_OF_YEAR);
					if(y1 == y2 && d1 == d2) return false;
				}
				file_bak.delete();
			}
			self.debug("rename to '%s'.", file_bak);
			return file.renameTo(file_bak);
		} else {
			self.debug("'%s' not exists.", file);
		}
		return false;
	}
	
	/** @see {@link #renameToBak(File, boolean)} */
	public static boolean renameToBak(File file) {
		return renameToBak(file, false);
	}
	
}
